//------------------------------------
//  winnie.cpp
//  (c) Bartosz Milewski, 1995
//------------------------------------

#include "winnie.h"

// This is the entry point of every Windows program
int WINAPI WinMain
   (HINSTANCE hInst, HINSTANCE hPrevInst, char * cmdParam, int cmdShow)
{
    char className [] = "Winnie";

    main_wnd_class.style = 0;
    main_wnd_class.lpfnWndProc = MainWindowProcedure;  // Window Procedure: mandatory
    main_wnd_class.cbClsExtra = 0;
    main_wnd_class.cbWndExtra = 0;
    main_wnd_class.hInstance = hInst;           // owner of the class: mandatory
    main_wnd_class.hIcon = 0;
    main_wnd_class.hCursor = ::LoadCursor (0, IDC_ARROW); // optional
    main_wnd_class.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1); // optional
    main_wnd_class.lpszMenuName = 0;
    main_wnd_class.lpszClassName = className;   // mandatory

		RegisterClass (&main_wnd_class);

    hmain_wnd = CreateWindow (
        className,              // name of a registered window class
        "Hello Windows!",                // window caption
        WS_OVERLAPPEDWINDOW,    // window style
        CW_USEDEFAULT,          // x position
        CW_USEDEFAULT,          // y position
        CW_USEDEFAULT,          // witdh
        CW_USEDEFAULT,          // height
        0,                      // handle to parent window
        0,                      // handle to menu
        hInst,              // application instance
        0 );                    // window creation data


		ShowWindow (hmain_wnd, cmdShow);
		UpdateWindow (hmain_wnd);

    MSG  msg;
    int status;
	// Keep pumping messages--they end up in our Window Procedure
    while ((status = GetMessage (&msg, 0, 0, 0)) != 0)
    {
        if (status == -1)
            return -1;
        DispatchMessage (&msg);
    }

    return msg.wParam;
}


// Window Procedure called by Windows with all kinds of messages
LRESULT CALLBACK MainWindowProcedure 
    (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
		// In this simple program, this is the only message we are processing
        case WM_DESTROY:
            PostQuitMessage (0);
            return 0; // return zero when processed

    }
	// All the unprocessed messages go there, to be dealt in some default way
    return DefWindowProc (hwnd, message, wParam, lParam );
}

